/*

EGYPT Toolkit for Statistical Machine Translation
Written by Yaser Al-Onaizan, Jan Curin, Michael Jahr, Kevin Knight, John Lafferty, Dan Melamed, David Purdy, Franz Och, Noah Smith, and David Yarowsky.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
USA.

*/
#ifndef _defs_h
#define _defs_h 1
#include <string>
#include <math.h>
//#include "logprob.h"
#include <limits.h>

const int MAX_ITERATIONS_MODEL1=3;
const int MAX_ITERATIONS_MODEL2=3;
const int MAX_ITERATIONS_MODEL3=3;
const int MAX_ITERATIONS_MODEL4=0;
const int TABLE_DUMP_FREQ_1=1 ;
const int TABLE_DUMP_FREQ_2=1 ;
const int TABLE_DUMP_FREQ_3=1; 
const int TABLE_DUMP_FREQ_T=1; 
const int TRANSFER_SIMPLE=1;
const int TRANSFER=0;
const unsigned int MAX_SENTENCE_LENGTH_ALLOWED=41;

const int TRAIN_BUFFER_SIZE= 100000 ;
#ifdef WORDINDEX_WITH_4_BYTE
typedef unsigned int WordIndex;
const unsigned int MAX_VOCAB_SIZE=UINT_MAX;
#else
typedef unsigned short WordIndex;
const unsigned int MAX_VOCAB_SIZE=USHRT_MAX;
#endif
const WordIndex MAX_FERTILITY=10;
//const WordIndex MAX_FERTILITY=MAX_SENTENCE_LENGTH;

extern float PROB_CUTOFF,COUNTINCREASE_CUTOFF,PROB_SMOOTH;
const double PEGGED_CUTOFF=1E-30;
const int MAX_W=13001;
const double LAMBDA=1.09; // Lambda that is used to scale cross_entropy factor

typedef float PROB ;
typedef float COUNT ;

/*
class LogProb {
 private:
  double x ;
 public:
  LogProb():x(0){}
  LogProb(double y):x(y){}
  LogProb(float y):x(y){}
  LogProb(int y):x(y){}
  LogProb(WordIndex y):x(y){}
  operator double() const {return x;}
  LogProb operator *= (double y) { x *= y ; return *this;}
  LogProb operator *= (LogProb y) { x *= y.x ; return *this;}
  LogProb operator /= (double y) { x /= y ; return *this;}
  LogProb operator /= (LogProb y) { x /= y.x ; return *this;}
  LogProb operator += (double y) { x += y ; return *this;}
  LogProb operator += (LogProb y) { x += y.x ; return *this;}
};
*/
extern int ADTableIgnoreL,ADTableIgnoreM,ADTableSpecial;
#endif
  
