/*

EGYPT Toolkit for Statistical Machine Translation
Written by Yaser Al-Onaizan, Jan Curin, Michael Jahr, Kevin Knight, John Lafferty, Dan Melamed, David Purdy, Franz Och, Noah Smith, and David Yarowsky.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
USA.

*/
#ifndef _model2_h
#define _model2_h 1

#include <assert.h>
 
#include <iostream>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
//#include <vector>
#include "Vector.h"
#include <utility>
#include <hash_map>
#include <fstream.h>
#include <math.h>
#include <time.h>

#include "TTables.h"
#include "ATables.h" 
#include "getSentence.h"
#include "defs.h"
#include "model1.h"
#include "Perplexity.h"
#include "vocab.h"

class model2{
private:
  //  int noEnglishWords;
  //int noFrenchWords;
  const vcbList&Elist;
  const vcbList&Flist;
  amodel<PROB> aTable;
  amodel<COUNT> aCountTable;

  string efFilename;
  
  
  float eTotalWCount ; // size of source copus in number of words
  float fTotalWCount ; // size of target corpus in number of words 


public:
  model2(model1& m1);
  // methods
  void initialize_table_uniformly();
  //  void em_with_tricks(tmodel&, tmodel&, Vector<WordEntry>&, Vector<WordEntry>&, int);
  void em_with_tricks(tmodel<COUNT, PROB>&, int, Perplexity& , sentenceHandler&, 
		      Perplexity*, sentenceHandler*, Perplexity&, Perplexity&);
  void load_table(const char* aname);

  inline amodel<PROB>& getATable(void) {return aTable;};
  inline amodel<COUNT>& getACountTable(void) {return aCountTable;};
  void em_loop(int model, tmodel<COUNT, PROB>& tTable, int it, Perplexity& perp, 
	       sentenceHandler& sHandler1, bool dump_files, 
	       const char* alignfile, Perplexity&, bool test);
  friend class model3;
};



#endif
